CreateClient: 
    name: CreateClient
    handler: src/handler/create-client.handler
    environment:
      CREATE_CLIENT_TABLE: !Ref CreateClientTable
      TOPIC_CREATE_CLIENT_TABLE: !Ref CreateClientTopic
      QUEUE_CREATE_CARD: !Ref QueueCard
      QUEUE_CREATE_GIFT: !Ref QueueGift
    iamRoleStatementsInherit: true
    iamRoleStatements: 
      - Effect: Allow
        Action:
          - dynamodb:PutItem
        Resource:
          - !GetAtt CreateClientTable.Arn
      - Effect: Allow
        Action:
          - sns:Publish
        Resource:
          - !Ref CreateClientTopic
      - Effect: Allow
        Action:
          - sqs:SendMessage
        Resource:
          - !GetAtt QueueCard.Arn
      - Effect: Allow
        Action:
          - sqs:SendMessage
        Resource:
          - !GetAtt QueueGift.Arn
    events:
      - http:
          path: client
          method: POST

GetClient:
    name: GetClient
    handler: src/handler/get-client.handler
    environment:
      CREATE_CLIENT_TABLE: !Ref CreateClientTable
    events:
      - http:
          path: client/{id}
          method: GET
    iamRoleStatementsInherit: true
    iamRoleStatements:
      - Effect: Allow
        Action:
          - dynamodb:GetItem
        Resource:
          - !GetAtt CreateClientTable.Arn

GetClients:
    name: GetClients
    handler: src/handler/get-clients.handler
    environment:
      CREATE_CLIENT_TABLE: !Ref CreateClientTable
    events:
      - http:
          path: clients
          method: GET
    iamRoleStatementsInherit: true
    iamRoleStatements:
      - Effect: Allow
        Action:
          - dynamodb:Scan
        Resource:
          - !GetAtt CreateClientTable.Arn
          
UpdateClient:
    name: UpdateClient
    handler: src/handler/update-client.handler
    environment:
      CREATE_CLIENT_TABLE: !Ref CreateClientTable
      TOPIC_CREATE_CLIENT_TABLE: !Ref CreateClientTopic
      QUEUE_CREATE_CARD: !Ref QueueCard
      QUEUE_CREATE_GIFT: !Ref QueueGift
    events:
      - http:
          path: client/{id}
          method: PUT
    iamRoleStatementsInherit: true
    iamRoleStatements:
      - Effect: Allow
        Action:
          - dynamodb:UpdateItem
        Resource:
          - !GetAtt CreateClientTable.Arn
      - Effect: Allow
        Action:
          - sns:Publish
        Resource:
          - !Ref CreateClientTopic
      - Effect: Allow
        Action:
          - sqs:SendMessage
        Resource:
          - !GetAtt QueueCard.Arn
      - Effect: Allow
        Action:
          - sqs:SendMessage
        Resource:
          - !GetAtt QueueGift.Arn

DeleteClient:
    name: DeleteClient
    handler: src/handler/delete-client.handler
    environment:
      CREATE_CLIENT_TABLE: !Ref CreateClientTable
    events:
      - http:
          path: client/{id}
          method: DELETE
    iamRoleStatementsInherit: true
    iamRoleStatements:
      - Effect: Allow
        Action:
          - dynamodb:UpdateItem
        Resource:
          - !GetAtt CreateClientTable.Arn

CreateCard: 
      name: CreateCard
      handler: src/handler/create-card.handler
      environment:
        CREATE_CLIENT_TABLE: !Ref CreateClientTable
      iamRoleStatementsInherit: true
      iamRoleStatements: 
        - Effect: Allow
          Action:
            - dynamodb:UpdateItem
          Resource:
            - !GetAtt CreateClientTable.Arn
      events:
      - sqs:
          arn:
            Fn::GetAtt:
              - QueueCard
              - Arn

CreateGift: 
      name: CreateGift
      handler: src/handler/create-gift.handler
      environment:
        CREATE_CLIENT_TABLE: !Ref CreateClientTable
      iamRoleStatementsInherit: true
      iamRoleStatements: 
        - Effect: Allow
          Action:
            - dynamodb:UpdateItem
          Resource:
            - !GetAtt CreateClientTable.Arn
      events:
      - sqs:
          arn:
            Fn::GetAtt:
              - QueueGift
              - Arn

CreatePurchase: 
    name: CreatePurchase
    handler: src/handler/create-purchase.handler
    environment:
      CREATE_PURCHASE_TABLE: !Ref CreatePurchaseTable
      CREATE_CLIENT_TABLE: !Ref CreateClientTable
    iamRoleStatementsInherit: true
    iamRoleStatements: 
      - Effect: Allow
        Action:
          - dynamodb:PutItem
        Resource:
          - !GetAtt CreatePurchaseTable.Arn
      - Effect: Allow
        Action:
          - dynamodb:GetItem
        Resource:
          - !GetAtt CreateClientTable.Arn
      - Effect: Allow
        Action:
          - dynamodb:UpdateItem
        Resource:
          - !GetAtt CreateClientTable.Arn
    events:
      - http:
          path: purchase
          method: POST